<template>
  <div>
    <v-app>
      <v-navigation-drawer
        elevation="2"
        width="320"
        v-model="drawer"
        fixed
        temporary
        overlay-opacity="0.4"
      >
        <v-main>
          <div id="menuPrincipal">
            <div class="header-usuario">
              <div id="foto">
                <img src="@/assets/img/logo.svg" class="imgLogo" />
              </div>
              <div id="inf-usuario">
                <span>Plataforma de Franquicia</span>
                <br />Menú Principal
                <br />
              </div>
            </div>
            <div>
              <Menu />
            </div>
          </div>
        </v-main>
      </v-navigation-drawer>
      <v-app-bar elevation="0" class="headerBar" height="49" app>
        <div class="loader">
          <v-progress-linear
            :active="isLoading"
            :indeterminate="isLoading"
            height="10"
            buffer-value="0"
            :stream="true"
            background-opacity="0"
            color="primary"
            absolute
            top
          ></v-progress-linear>
        </div>
        <v-row no-gutters>
          <v-col cols="4" class="pa-2">
            <v-app-bar-nav-icon
              @click.stop="drawer = !drawer"
            ></v-app-bar-nav-icon>
          </v-col>
          <v-col cols="4" class="pa-2">
            <div class="headerLogo">
              <router-link to="/">
                <img src="@/assets/img/logo.svg" id="imgLogo" />
              </router-link>
            </div>
          </v-col>
          <v-col cols="4" class="pa-2">
            <div class="headerUser">
              <div class="name">
                {{ serviceCommons.titleCase(user.nombre) }}
                <v-divider></v-divider>
                <v-btn
                  class="mt-1"
                  tile
                  depressed
                  x-small
                  color="secondary"
                  @click="closeSession()"
                >
                  Salir -
                  <v-icon size="15">mdi-door-closed-lock</v-icon>
                </v-btn>
              </div>
            </div>
          </v-col>
        </v-row>
      </v-app-bar>
      <v-main>
        <component v-bind:is="component" />
      </v-main>
      <v-footer app class="pa-0">
        <div class="float-left">
          Plataforma franquicia
          <v-icon color="primary" small>mdi-power-on</v-icon> Prohibida la
          reproducción parcial o total de este contenido, por cualquier medio
          físico o electrónico (incluye fotos y videos)
        </div>
        <Version class="float-left" style="position: absolute" />
      </v-footer>
    </v-app>
    <template>
      <v-dialog v-model="dialogErrorServer" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh!</strong>
            Estamos experimentando unos problemas
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <template v-if="subTitleError">
              <div class="h6 overline">{{ subTitleError }}</div>
            </template>
            ¡No hay de que preocuparse! Ya estamos trabajando en ello, estaremos
            de regreso pronto.
            <template v-if="folioError">
              <strong
                >Puedes reportar este incidente con este folio
                {{ folioError }}</strong
              >
            </template>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="
                  $store.state.dialogErrorServer = false;
                  folioError = null;
                  subTitleError = null;
                "
                >Aceptar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSessionFinish" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tu sesión termino por ahora
            </div>
          </v-card-title>
          <v-card-text>
            ¡Por tu seguridad! Es necesario mantener un tiempo limite en la
            sesión.
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="closeSession()"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogOthersSessions" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Detectamos multiples sesiones abiertas desde tu cuenta
            </div>
          </v-card-title>
          <v-card-text>
            ¡Por tu seguridad! Te sugerimos mantener solamente una sesión
            activa. ¿Deseas inhabilitar las sesiones activas en los siguientes
            dispositivos?
            <div style="max-height: 150px; overflow: auto; overflow-x: hidden">
              <v-row dense>
                <v-col
                  v-for="(itemAccess, indexItemAccess) in otherAccess"
                  :key="indexItemAccess"
                  :cols="6"
                >
                  <v-card>
                    <v-card-title>Acceso desde... </v-card-title>
                    <v-card-subtitle>
                      Fecha acceso {{ itemAccess.fecha_inicio }}
                    </v-card-subtitle>
                    <v-card-text>
                      Sistema Operativo
                      {{ itemAccess.nombre_sistema_operativo }}
                      <v-divider></v-divider>
                      Navegador
                      {{ itemAccess.nombre_navegador }}
                    </v-card-text>
                  </v-card>
                </v-col>
              </v-row>
            </div>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogOthersSessions = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="closeOthersSessions()"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>

<style scoped>
.loader {
  height: 10px;
  width: 100%;
  position: absolute;
  top: 0;
}

.v-navigation-drawer--temporary {
  z-index: 4;
}

.l-navegacion li {
  background-color: inherit;
}
</style>

<script>
import ValidandoAccesos from "@/views/secure/privilegios/perfilamiento-excepciones/ValidandoAccesos.vue";
import AccesoDenegado from "@/views/secure/privilegios/perfilamiento-excepciones/AccesoDenegado.vue";
import SinAccesos from "@/views/secure/privilegios/perfilamiento-excepciones/SinAccesos.vue";
import MainAccess from "@/views/secure/MainAccess.vue";
import NotFound404 from "@/views/errors/404.vue";
import { mapState } from "vuex";
import axios from "axios";
import store from "@/store";
import router from "@/router";
import Version from "@/views/Version";
import Menu from "@/views/secure/menu/Menu";
import LocalStorage from "@/services/storage/LocalStorage";
import querystring from "querystring";
import createAuthRefreshInterceptor from "axios-auth-refresh";
const LocalStorageService = LocalStorage.getService();
const axiosChecklist = store.state.axiosChecklist;
const axiosGestion = store.state.axiosGestion;
const axiosApiLocal = store.state.axiosApiLocal;
const axiosPFA = store.state.axiosPFA;
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-LoggedLayOut",
  components: {
    Version,
    Menu,
    AccesoDenegado,
    ValidandoAccesos,
    NotFound404,
    SinAccesos,
    MainAccess,
  },
  data() {
    return {
      drawer: false,
      dialogOthersSessions: false,
      currentAccess: null,
      otherAccess: null,
      trigger: false,
      path: null,
      folioError: null,
      subTitleError: null,
    };
  },
  computed: {
    ...mapState([
      "isLoading",
      "refCount",
      "dialogErrorServer",
      "dialogSessionFinish",
      "urlLogout",
      "production",
      "isLoginSaml",
    ]),
    component() {
      //Perfil 3 Sistemas
      let accessValidation = true;
      let usuariosSistemas = [
        664899,
        165943,
        202622,
        176361,
        331952,
        189871,
        191312,
        196228,
        976479,
        189140,
        370566,
        73610,
        73606,
      ];
      usuariosSistemas.forEach((usuario) => {
        let user = serviceLocalStorage.userToken();
        if (usuario === user.empleado) {
          accessValidation = false;
        }
      });
      if (accessValidation) {
        if (!this.path) {
          return "ValidandoAccesos";
        }
        if (!this.trigger) {
          return "ValidandoAccesos";
        }
        let hasRoute = store.state.modulos.filter(
          (itemModulo) => itemModulo.modulo.descripcion === this.path
        );
        if (store.state.perfiles.length == 0) {
          store.state.component = "SinAccesos";
        } else if (hasRoute.length > 0 || this.path === "home") {
          store.state.component = "MainAccess";
        } else {
          store.state.component = "AccesoDenegado";
        }

        return store.state.component;
      } else {
        return "MainAccess";
      }
    },
    serviceCommons() {
      return serviceCommons;
    },
    user() {
      let user = serviceLocalStorage.userToken();
      if (!user) {
        user = {};
      }
      return user;
    },
  },
  methods: {
    getPerfilesUsuario() {
      store.state.perfiles = [];
      store.state.modulos = [];
      const user = serviceLocalStorage.userToken();
      return axios
        .get("/usuario/secure/get/deep/perfiles/" + user.empleado)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              let perfiles = response.data.data.perfiles;
              this.setPerfilesUsuario(perfiles);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfilesUsuario(data) {
      let modulos = [];
      store.state.perfiles = data;
      if (store.state.perfiles) {
        store.state.perfiles.forEach((itemPerfil) => {
          itemPerfil.flujos.forEach((itemFlujoPerfil) => {
            itemFlujoPerfil.modulos.forEach((itemModuloFlujo) => {
              modulos.push(itemModuloFlujo);
            });
          });
        });
      }
      store.state.modulos = modulos;
      this.trigger = !this.trigger;
    },
    getModulosTree() {
      const user = serviceLocalStorage.userToken();
      var self = this;
      axios
        .get("/usuario/secure/get/deep/modulos/" + user.empleado)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data.modulos;
              self.setModulosTree(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setModulosTree(data) {
      if (data) {
        let finalData = [];
        const excludeHidenItems = function(data) {
          if (data.children) {
            data.children = data.children.filter((item) => !item.oculto_menu);
            data.children.forEach((itemModulo) => {
              excludeHidenItems(itemModulo);
            });
          }
        };
        data.forEach((itemModulo) => {
          excludeHidenItems(itemModulo);
        });
        store.state.modulosTree = data.sort((a, b) =>
          a.id_flujo_modulo > b.id_flujo_modulo
            ? 1
            : b.id_flujo_modulo > a.id_flujo_modulo
            ? -1
            : 0
        );
      }
    },
    deleteCookie(cname) {
      serviceCommons.deleteCookie(cname);
    },
    closeSession() {
      serviceLocalStorage.clearToken();
      this.deleteCookie("login_saml");
      this.deleteCookie("user");
      store.state.dialogSessionFinish = false;
      store.state.isLogged = false;
      if (this.production && this.isLoginSaml) {
        location.href = this.urlLogout;
      } else {
        if (this.production) {
          axiosPFA.get("/session/logout");
        }
        router.push({
          name: "login_alternative",
        });
      }
      store.state.perfiles = [];
      store.state.modulos = [];
      store.state.component = "ValidandoAccesos";
    },
    closeOthersSessions() {
      const self = this;
      axiosPFA
        .get(
          "/session/logout/others/" +
            self.user.empleado +
            "/" +
            self.currentAccess.http_session
        )
        .then((response) => {
          if (response) {
            console.log(response.data);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          store.state.dialogOthersSessions = false;
        });
    },
    getAllCurrentAccessLogs() {
      const self = this;
      axiosPFA
        .get("/session/get/all/current/access/logs/" + self.user.empleado)
        .then((response) => {
          if (response) {
            if (!response.data.current_access) {
              console.log("Conflicto al obtener la sesion actual");
              //store.state.dialogSessionFinish = true;
            }
            if (
              response.data.other_access &&
              response.data.other_access.length > 0
            ) {
              self.currentAccess = response.data.current_access;
              self.otherAccess = response.data.other_access;
              self.dialogOthersSessions = true;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.dialogOthersSessions = false;
        });
    },
    interceptorsSetToken(axiosInstance) {
      // Add a request interceptor
      axiosInstance.interceptors.request.use(
        (config) => {
          let accessToken = LocalStorageService.getAccessToken();
          config.headers["Authorization"] = "Bearer " + accessToken;
          config.headers["Content-Security-Policy"] = "script-src 'self'";
          return config;
        },
        (error) => {
          Promise.reject(error);
        }
      );
      // Function that will be called to refresh authorization
      const refreshAuthLogic = (failedRequest) =>
        axiosInstance
          .request({
            method: "POST",
            data: querystring.stringify({
              grant_type: "refresh_token",
              refresh_token: LocalStorageService.getRefreshToken(),
            }),
            headers: {
              "content-type": "application/x-www-form-urlencoded;charset=utf-8",
            },
            auth: {
              username: "frontendapp",
              password: "12345",
            },
            url: "/security/oauth/token",
          })
          .then((tokenRefreshResponse) => {
            LocalStorageService.setToken(tokenRefreshResponse.data);
            let accessToken = LocalStorageService.getAccessToken();
            failedRequest.response.config.headers["Authentication"] =
              "Bearer " + accessToken;
            return Promise.resolve();
          })
          .catch((error) => {
            console.log(error);
          });
      // Instantiate the interceptor (you can chain it as it returns the axiosInstance instance)
      createAuthRefreshInterceptor(axiosInstance, refreshAuthLogic, {
        retryInstance: axiosInstance,
        pauseInstanceWhileRefreshing: true,
      });
    },
    customInterceptors(axiosInstance) {
      axiosInstance.interceptors.request.use(
        (config) => {
          let data = config.data;
          if (config.baseURL) {
            if (!config.baseURL.includes("/checklist")) {
              if (data) {
                let dataText = JSON.stringify(data);
                dataText = dataText.replaceAll("á", "á");
                dataText = dataText.replaceAll("é", "é");
                dataText = dataText.replaceAll("í", "í");
                dataText = dataText.replaceAll("ó", "ó");
                dataText = dataText.replaceAll("ú", "ú");
                dataText = dataText.replaceAll("ñ", "ñ");
                dataText = dataText.replaceAll("Á", "Á");
                dataText = dataText.replaceAll("É", "É");
                dataText = dataText.replaceAll("Í", "Í");
                dataText = dataText.replaceAll("Ó", "Ó");
                dataText = dataText.replaceAll("Ú", "Ú");
                dataText = dataText.replaceAll("Ñ", "Ñ");
                data = JSON.parse(dataText);
                config.data = data;
              }
            }
          }
          this.$store.commit("loading", true);
          return config;
        },
        (error) => {
          store.state.dialogErrorServer = true;
          this.$store.commit("loading", false);
          return Promise.reject(error);
        }
      );
      axiosInstance.interceptors.response.use(
        (response) => {
          if (!response) {
            store.state.dialogErrorServer = true;
          } else {
            if (axiosInstance === axios) {
              const file = response.config.responseType === "blob";
              const data = response.data;
              if (!file && data.status_code !== 200 && !data.refresh_token) {
                store.state.dialogErrorServer = true;
              }
            }
            if (axiosInstance === axiosChecklist) {
              const responseServer = response.data.response;
              if (responseServer !== undefined && !responseServer) {
                store.state.dialogErrorServer = true;
              }
            }
            if (axiosInstance === axiosApiLocal) {
              const responseServer = response.data;
              if (responseServer !== undefined && !responseServer) {
                store.state.dialogErrorServer = true;
              }
            }
          }
          this.$store.commit("loading", false);
          store.state.dialogSessionFinish = false;
          return response;
        },
        (error) => {
          this.$store.commit("loading", false);
          if (axiosInstance === axiosApiLocal) {
            const responseServer = error.response;
            if (
              responseServer &&
              (responseServer.status == 400 || responseServer.status >= 500)
            ) {
              store.state.dialogErrorServer = true;
              this.folioError = responseServer.data.folio;
              this.subTitleError = responseServer.data.mensaje;
            } else if (responseServer && responseServer.status == 401) {
              store.state.dialogSessionFinish = true;
            }
          } else {
            let errorString = error + "";
            if (errorString.includes("401")) {
              store.state.dialogSessionFinish = true;
            } else {
              store.state.dialogErrorServer = true;
            }
          }
          return Promise.reject(error);
        }
      );
    },
  },
  beforeCreate() {
    router.afterEach((to, from) => {
      this.path = to.name;
    });
    this.$nextTick().then(() => {
      this.path = this.$router.history.current.name;
    });
  },
  created() {
    this.deleteCookie("user");
    this.interceptorsSetToken(axiosApiLocal);
    this.customInterceptors(axios);
    this.customInterceptors(axiosChecklist);
    this.customInterceptors(axiosGestion);
    this.customInterceptors(axiosApiLocal);
    this.getPerfilesUsuario();
    this.getModulosTree();
    if (store.state.production) {
      if (store.state.isLogged) {
        this.getAllCurrentAccessLogs();
      }
    }
  },
  beforeRouteEnter: function(to, from, next) {
    if (store.state.isLogged) {
      next();
    } else {
      router.push({
        name: "login_alternative",
      });
    }
  },
};
</script>
